<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

  <body>
    <div class="container">
      <div class="text-center mt-4 mb-3">
        <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
      </div>
      <div class="jumbotron container">
        <div class="row form-group mb-0">
          <div class="col-sm-3 text-right">
            <label for="">Role</label>
          </div>
          <div class="col-sm-6">
            <select name="" id="role-select" class="form-control"></select>
          </div>
          <div class="col-sm-3">
            <button id="btn-filter-role" class="btn btn-info">
              Lọc dữ liệu
            </button>
          </div>
        </div>
      </div>

      <table
        id="user-table"
        class="table table-bordered table-striped table-hover"
      >
        <thead class="thead-dark">
          <tr>
            <th scope="col">STT</th>
            <th scope="col">Username</th>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
            <th scope="col">Email</th>
            <th scope="col">Age</th>
            <th scope="col">Role</th>
            <th scope="col">Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // Mảng gUserObjects là mảng chứa dữ liệu users
      var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5,
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8,
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11,
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13,
        },
      ];
      // Mảng gRoleObjects là mảng chứa dữ liệu các roles
      var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin",
        },
        {
          roleId: 8,
          roleName: "Manager",
        },
        {
          roleId: 11,
          roleName: "Teacher",
        },
        {
          roleId: 13,
          roleName: "Staff",
        },
      ];

      var gNameCol = [
        "stt",
        "username",
        "firstname",
        "lastname",
        "email",
        "age",
        "roleId",
        "action",
      ];

      const gSTT_COL = 0;
      const gUSER_NAME_COL = 1;
      const gFIRST_NAME_COL = 2;
      const gLAST_NAME_COL = 3;
      const gEMAIL_COL = 4;
      const gAGE_COL = 5;
      const gROLE_COL = 6;
      const gACTION_COL = 7;
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      $("#btn-filter-role").on("click", function () {
        onBtnLocDuLieuClick();
      });

      $(document).on("click", ".btn-dice-history", function () {
        onBtnHistoryDiceClick(this);
      });

      $(document).on("click", ".btn-voucher-history", function () {
        onBtnHistoryVoucherClick(this);
      });
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm thực thi khi tải trang
      function onPageLoading() {
        loadDataToRoleSelect();
        showTableUserDataTable();
      }

      //hàm thực thi khi nhấn nút Lọc dữ liệu
      function onBtnLocDuLieuClick() {
        var vFilterRoleId = {
          roleId: -1,
        };

        //B1: thu thập dữ liệu
        getFilterData(vFilterRoleId);
        //B3: xử lý filter
        filterRoles(vFilterRoleId);
      }

      //hàm thực thi khi nhấn nút icon Dice History
      function onBtnHistoryDiceClick(paramBtnElement) {
        var vDataRow = getDataRow(paramBtnElement);

        const vDETAIL_FORM_URL = "task 43.40.html";
        var vUrlSiteToOpen =
          vDETAIL_FORM_URL +
          "?user_name=" +
          vDataRow.username +
          "&first_name=" +
          vDataRow.firstname +
          "&last_name=" +
          vDataRow.lastname;
        location.href = vUrlSiteToOpen;
      }

      //hàm thực thi khi nhấn nút icon Voucher History
      function onBtnHistoryVoucherClick(paramBtnElement) {
        var vDataRow = getDataRow(paramBtnElement);

        const vDETAIL_FORM_URL = "voucherHistory.html";
        var vUrlSiteToOpen =
          vDETAIL_FORM_URL +
          "?user_name=" +
          vDataRow.username +
          "&first_name=" +
          vDataRow.firstname +
          "&last_name=" +
          vDataRow.lastname;
        location.href = vUrlSiteToOpen;
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm load role lên Select Role trên ưeb
      function loadDataToRoleSelect() {
        var vRoleSelect = $("#role-select");
        $("<option/>", {
          text: "--- Chọn tất cả ---",
          value: 0,
        }).appendTo(vRoleSelect);

        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          var bRoleOption = $("<option/>", {
            text: gRoleObjects[bI].roleName,
            value: gRoleObjects[bI].roleId,
          }).appendTo(vRoleSelect);
        }
      }

      //hàm load user lên table trên web
      function showTableUserDataTable() {
        $("#user-table").DataTable({
          data: gUserObjects,
          columns: [
            { data: gNameCol[gSTT_COL] },
            { data: gNameCol[gUSER_NAME_COL] },
            { data: gNameCol[gFIRST_NAME_COL] },
            { data: gNameCol[gLAST_NAME_COL] },
            { data: gNameCol[gEMAIL_COL] },
            { data: gNameCol[gAGE_COL] },
            { data: gNameCol[gROLE_COL] },
            { data: gNameCol[gACTION_COL] },
          ], // Các thuộc tính của USER sẽ match với từng column
          columnDefs: [
            //định nghĩa các cột cần hiện ra
            {
              targets: gSTT_COL, //cột STT
              className: "text-center text-primary",
              render: function (data, type, row, meta) {
                return meta.row + meta.settings._iDisplayStart + 1;
              },
            },
            {
              targets: gROLE_COL,
              className: "text-right",
              render: mappingRoleNameByID,
            },
            {
              targets: gACTION_COL, //cột Action
              className: "text-center",
              defaultContent: `
                <button class="btn btn-link btn-dice-history" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
                <button class="btn btn-link btn-sm btn-voucher-history" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`,
            },
          ],
        });
      }

      //hàm render từ role id thành role name
      function mappingRoleNameByID(paramData, paramType, paramRow) {
        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          const bRoleObjItem = gRoleObjects[bI];
          if (paramData == bRoleObjItem.roleId) {
            return bRoleObjItem.roleName;
          }
        }
      }

      //hàm thu thập dữ liệu để lọc
      function getFilterData(paramFilterObj) {
        paramFilterObj.roleId = parseInt($("#role-select").val(), 10);
      }

      //hàm lọc và load kết quả vào table
      function filterRoles(paramFilterObj) {
        var vRolesResult = [];
        vRolesResult = gUserObjects.filter(function (paramUser) {
          return (
            paramFilterObj.roleId === 0 ||
            paramUser.roleId === paramFilterObj.roleId
          );
        });
        console.log(vRolesResult);

        //load kết quả lên table
        $("#user-table").DataTable().clear();
        $("#user-table").DataTable().rows.add(vRolesResult);
        $("#user-table").DataTable().draw();
      }

      //hàm lấy data row dựa vào nút đã ấn
      function getDataRow(paramBtn) {
        var vRow = $(paramBtn).parents("tr");
        var vRowData = $("#user-table").DataTable().row(vRow).data();
        return vRowData;
      }
    </script>
  </body>
</html>
